Index: issm/trunk/src/m/classes/matestar.m
===================================================================
--- issm/trunk/src/m/classes/matestar.m	(revision 25994)
+++ issm/trunk/src/m/classes/matestar.m	(revision 26744)
@@ -6,30 +6,24 @@
 classdef matestar
 	properties (SetAccess=public) 
-		rho_ice                    = 0.;
-		rho_water                  = 0.;
-		rho_freshwater             = 0.;
-		mu_water                   = 0.;
-		heatcapacity               = 0.;
-		latentheat                 = 0.;
-		thermalconductivity        = 0.;
-		temperateiceconductivity   = 0.;
+		rho_ice                         = 0.;
+		rho_water                       = 0.;
+		rho_freshwater                  = 0.;
+		mu_water                        = 0.;
+		heatcapacity                    = 0.;
+		latentheat                      = 0.;
+		thermalconductivity             = 0.;
+		temperateiceconductivity        = 0.;
 		effectiveconductivity_averaging = 0;
-		meltingpoint               = 0.;
-		beta                       = 0.;
-		mixed_layer_capacity       = 0.;
-		thermal_exchange_velocity  = 0.;
-		rheology_B    = NaN;
-		rheology_Ec   = NaN;
-		rheology_Es   = NaN;
-		rheology_law = '';
+		meltingpoint                    = 0.;
+		beta                            = 0.;
+		mixed_layer_capacity            = 0.;
+		thermal_exchange_velocity       = 0.;
+		rheology_B                      = NaN;
+		rheology_Ec                     = NaN;
+		rheology_Es                     = NaN;
+		rheology_law                    = '';
 
-		%giaivins: 
-		lithosphere_shear_modulus  = 0.;
-		lithosphere_density        = 0.;
-		mantle_shear_modulus       = 0.;
-		mantle_density             = 0.;
-
-		%slr
-		earth_density              = 0;
+		%SLC
+		earth_density                   = 0;
 
 	end
@@ -93,5 +87,5 @@
 			%computation of effective conductivity
 			self.effectiveconductivity_averaging=1;
-            
+
 			%the melting point of ice at 1 atmosphere of pressure in K
 			self.meltingpoint=273.15;
@@ -110,12 +104,6 @@
 			self.rheology_law='Paterson';
 
-			% GIA:
-			self.lithosphere_shear_modulus  = 6.7*10^10;  % (Pa)
-			self.lithosphere_density        = 3.32;       % (g/cm^-3)
-			self.mantle_shear_modulus       = 1.45*10^11; % (Pa)
-			self.mantle_density             = 3.34;       % (g/cm^-3)
-
-			%SLR
-			self.earth_density= 5512;  % average density of the Earth, (kg/m^3)
+			%SLC
+			self.earth_density= 5512; % average density of the Earth, (kg/m^3)
 
 		end % }}}
@@ -130,12 +118,6 @@
 			md = checkfield(md,'fieldname','materials.rheology_law','values',{'None' 'BuddJacka' 'Cuffey' 'CuffeyTemperate' 'Paterson' 'Arrhenius' 'LliboutryDuval'});
 			md = checkfield(md,'fieldname','materials.effectiveconductivity_averaging','numel',[1],'values',[0 1 2]);
-            
-			if ismember('GiaAnalysis',analyses),
-				md = checkfield(md,'fieldname','materials.lithosphere_shear_modulus','>',0,'numel',1);
-				md = checkfield(md,'fieldname','materials.lithosphere_density','>',0,'numel',1);
-				md = checkfield(md,'fieldname','materials.mantle_shear_modulus','>',0,'numel',1);
-				md = checkfield(md,'fieldname','materials.mantle_density','>',0,'numel',1);
-			end
-			if ismember('SealevelriseAnalysis',analyses),
+
+			if ismember('SealevelchangeAnalysis',analyses),
 				md = checkfield(md,'fieldname','materials.earth_density','>',0,'numel',1);
 			end
@@ -162,8 +144,4 @@
 			fielddisplay(self,'rheology_Es','shear enhancement factor');
 			fielddisplay(self,'rheology_law',['law for the temperature dependance of the rheology: ''None'', ''BuddJacka'', ''Cuffey'', ''CuffeyTemperate'', ''Paterson'', ''Arrhenius'' or ''LliboutryDuval''']);
-			fielddisplay(self,'lithosphere_shear_modulus','Lithosphere shear modulus [Pa]');
-			fielddisplay(self,'lithosphere_density','Lithosphere density [g/cm^-3]');
-			fielddisplay(self,'mantle_shear_modulus','Mantle shear modulus [Pa]');
-			fielddisplay(self,'mantle_density','Mantle density [g/cm^-3]');
 			fielddisplay(self,'earth_density','Mantle density [kg/m^-3]');
 		end % }}}
@@ -188,8 +166,4 @@
 			WriteData(fid,prefix,'data',self.rheology_law,'name','md.materials.rheology_law','format','String');
 
-			WriteData(fid,prefix,'object',self,'class','materials','fieldname','lithosphere_shear_modulus','format','Double');
-			WriteData(fid,prefix,'object',self,'class','materials','fieldname','lithosphere_density','format','Double','scale',10^3);
-			WriteData(fid,prefix,'object',self,'class','materials','fieldname','mantle_shear_modulus','format','Double');
-			WriteData(fid,prefix,'object',self,'class','materials','fieldname','mantle_density','format','Double','scale',10^3);
 			WriteData(fid,prefix,'object',self,'class','materials','fieldname','earth_density','format','Double');
 		end % }}}
@@ -214,8 +188,4 @@
 			writejs1Darray(fid,[modelname '.materials.rheology_Es'],self.rheology_Es);
 			writejsstring(fid,[modelname '.materials.rheology_law'],self.rheology_law);
-			writejsdouble(fid,[modelname '.materials.lithosphere_shear_modulus'],self.lithosphere_shear_modulus);
-			writejsdouble(fid,[modelname '.materials.lithosphere_density'],self.lithosphere_density);
-			writejsdouble(fid,[modelname '.materials.mantle_shear_modulus'],self.mantle_shear_modulus);
-			writejsdouble(fid,[modelname '.materials.mantle_density'],self.mantle_density);
 			writejsdouble(fid,[modelname '.materials.earth_density'],self.earth_density);
 
Index: issm/trunk/src/m/classes/matestar.py
===================================================================
--- issm/trunk/src/m/classes/matestar.py	(revision 25994)
+++ issm/trunk/src/m/classes/matestar.py	(revision 26744)
@@ -8,12 +8,11 @@
 
 class matestar(object):
-    '''
-    MATESTAR class definition
+    """MATESTAR class definition
 
-        Usage:
-            matestar = matestar()
-    '''
+    Usage:
+        matestar = matestar()
+    """
 
-    def __init__(self): #{{{
+    def __init__(self):  # {{{
         self.rho_ice = 0.
         self.rho_water = 0.
@@ -34,46 +33,36 @@
         self.rheology_law = ''
 
-        #GIA
-        self.lithosphere_shear_modulus = 0.
-        self.lithosphere_density = 0.
-        self.mantle_shear_modulus = 0.
-        self.mantle_density = 0.
-
-        #SLR
+        # SLC
         self.earth_density = 0
 
-        #set default parameters
+        # Set default parameters
         self.setdefaultparameters()
-    #}}}
+    # }}}
 
-    def __repr__(self): #{{{
-        s = "   Materials:"
-        s = "%s\n%s" % (s, fielddisplay(self, 'rho_ice', 'ice density [kg/m^3]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'rho_water', 'ocean water density [kg/m^3]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'rho_freshwater', 'fresh water density [kg/m^3]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'mu_water', 'water viscosity [N s/m^2]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'heatcapacity', 'heat capacity [J/kg/K]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'thermalconductivity', ['ice thermal conductivity [W/m/K]']))
-        s = "%s\n%s" % (s, fielddisplay(self, 'temperateiceconductivity', 'temperate ice thermal conductivity [W/m/K]'))
-        s = "%s\n%s" % (s, fielddisplay(self, "effectiveconductivity_averaging", "computation of effectiveconductivity: (0) arithmetic mean, (1) harmonic mean, (2) geometric mean (default)"))
-        s = "%s\n%s" % (s, fielddisplay(self, 'meltingpoint', 'melting point of ice at 1atm in K'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'latentheat', 'latent heat of fusion [J / kg]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'beta', 'rate of change of melting point with pressure [K/Pa]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'mixed_layer_capacity', 'mixed layer capacity [W/kg/K]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'thermal_exchange_velocity', 'thermal exchange velocity [m/s]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'rheology_B', 'flow law parameter [Pa s^(1/3)]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'rheology_Ec', 'compressive enhancement factor'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'rheology_Es', 'shear enhancement factor'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'rheology_law', ['law for the temperature dependance of the rheology: ''None'', ''BuddJacka'', ''Cuffey'', ''CuffeyTemperate'', ''Paterson'', ''Arrhenius'' or ''LliboutryDuval''']))
-        s = "%s\n%s" % (s, fielddisplay(self, 'lithosphere_shear_modulus', 'Lithosphere shear modulus [Pa]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'lithosphere_density', 'Lithosphere density [g/cm^-3]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'mantle_shear_modulus', 'Mantle shear modulus [Pa]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'mantle_density', 'Mantle density [g/cm^-3]'))
-        s = "%s\n%s" % (s, fielddisplay(self, 'earth_density', 'Mantle density [kg/m^-3]'))
+    def __repr__(self):  # {{{
+        s = '   Materials:\n'
+        s += '{}\n'.format(fielddisplay(self, 'rho_ice', 'ice density [kg/m^3]'))
+        s += '{}\n'.format(fielddisplay(self, 'rho_water', 'ocean water density [kg/m^3]'))
+        s += '{}\n'.format(fielddisplay(self, 'rho_freshwater', 'fresh water density [kg/m^3]'))
+        s += '{}\n'.format(fielddisplay(self, 'mu_water', 'water viscosity [N s/m^2]'))
+        s += '{}\n'.format(fielddisplay(self, 'heatcapacity', 'heat capacity [J/kg/K]'))
+        s += '{}\n'.format(fielddisplay(self, 'thermalconductivity', ['ice thermal conductivity [W/m/K]']))
+        s += '{}\n'.format(fielddisplay(self, 'temperateiceconductivity', 'temperate ice thermal conductivity [W/m/K]'))
+        s += '{}\n'.format(fielddisplay(self, "effectiveconductivity_averaging", "computation of effectiveconductivity: (0) arithmetic mean, (1) harmonic mean, (2) geometric mean (default)"))
+        s += '{}\n'.format(fielddisplay(self, 'meltingpoint', 'melting point of ice at 1atm in K'))
+        s += '{}\n'.format(fielddisplay(self, 'latentheat', 'latent heat of fusion [J/kg]'))
+        s += '{}\n'.format(fielddisplay(self, 'beta', 'rate of change of melting point with pressure [K/Pa]'))
+        s += '{}\n'.format(fielddisplay(self, 'mixed_layer_capacity', 'mixed layer capacity [W/kg/K]'))
+        s += '{}\n'.format(fielddisplay(self, 'thermal_exchange_velocity', 'thermal exchange velocity [m/s]'))
+        s += '{}\n'.format(fielddisplay(self, 'rheology_B', 'flow law parameter [Pa s^(1/3)]'))
+        s += '{}\n'.format(fielddisplay(self, 'rheology_Ec', 'compressive enhancement factor'))
+        s += '{}\n'.format(fielddisplay(self, 'rheology_Es', 'shear enhancement factor'))
+        s += '{}\n'.format(fielddisplay(self, 'rheology_law', ['law for the temperature dependance of the rheology: \'None\', \'BuddJacka\', \'Cuffey\', \'CuffeyTemperate\', \'Paterson\', \'Arrhenius\' or \'LliboutryDuval\'']))
+        s += '{}\n'.format(fielddisplay(self, 'earth_density', 'Mantle density [kg/m^-3]'))
 
         return s
-    #}}}
+    # }}}
 
-    def extrude(self, md): #{{{
+    def extrude(self, md):  # {{{
         self.rheology_B = project3d(md, 'vector', self.rheology_B, 'type', 'node')
         self.rheology_Ec = project3d(md, 'vector', self.rheology_Ec, 'type', 'node')
@@ -81,48 +70,43 @@
 
         return self
-    #}}}
+    # }}}
 
-    def setdefaultparameters(self): #{{{
-        #ice density (kg / m^3)
-        self.rho_ice = 917.
-        #ocean water density (kg / m^3)
-        self.rho_water = 1023.
-        #fresh water density (kg / m^3)
-        self.rho_freshwater = 1000.
-        #water viscosity (N.s / m^2)
+    def setdefaultparameters(self):  # {{{
+        # Ice density (kg/m^3)
+        self.rho_ice = 917.0
+        # Ocean water density (kg/m^3)
+        self.rho_water = 1023.0
+        # Fresh water density (kg/m^3)
+        self.rho_freshwater = 1000.0
+        # Water viscosity (N.s/m^2)
         self.mu_water = 0.001787
-        #ice heat capacity cp (J / kg / K)
-        self.heatcapacity = 2093.
-        #ice latent heat of fusion L (J / kg)
-        self.latentheat = 3.34e5
-        #ice thermal conductivity (W / m / K)
+        # Ice heat capacity cp (J/kg/K)
+        self.heatcapacity = 2093.0
+        # Ice latent heat of fusion L (J/kg)
+        self.latentheat = 3.34 * pow(10, 5)
+        # Ice thermal conductivity (W/m/K)
         self.thermalconductivity = 2.4
-        #wet ice thermal conductivity (W / m / K)
+        # Wet ice thermal conductivity (W/m/K)
         self.temperateiceconductivity = 0.24
-        #computation of effective conductivity
+        # Computation of effective conductivity
         self.effectiveconductivity_averaging = 1
-        #the melting point of ice at 1 atmosphere of pressure in K
+        # The melting point of ice at 1 atmosphere of pressure in K
         self.meltingpoint = 273.15
-        #rate of change of melting point with pressure (K / Pa)
-        self.beta = 9.8e-8
-        #mixed layer (ice-water interface) heat capacity (J / kg / K)
-        self.mixed_layer_capacity = 3974.
-        #thermal exchange velocity (ice-water interface) (m / s)
-        self.thermal_exchange_velocity = 1.00e-4
-        #Rheology law: what is the temperature dependence of B with T
-        #available: none, paterson and arrhenius
+        # Rate of change of melting point with pressure (K/Pa)
+        self.beta = 9.8 * pow(10, -8)
+        # Mixed layer (ice-water interface) heat capacity (J/kg/K)
+        self.mixed_layer_capacity = 3974.0
+        # Thermal exchange velocity (ice-water interface) (m/s)
+        self.thermal_exchange_velocity = 1.00 * pow(10, -4)
+        # Rheology law: what is the temperature dependence of B with T
+        # available: none, paterson and arrhenius
         self.rheology_law = 'Paterson'
-        # GIA
-        self.lithosphere_shear_modulus = 6.7e10  # (Pa)
-        self.lithosphere_density = 3.32  # (g / cm^ - 3)
-        self.mantle_shear_modulus = 1.45e11  # (Pa)
-        self.mantle_density = 3.34  # (g / cm^ - 3)
-        #SLR
-        self.earth_density = 5512  # average density of the Earth, (kg / m^3)
+        # SLC
+        self.earth_density = 5512 # average density of the Earth (kg/m^3)
 
         return self
-    #}}}
+    # }}}
 
-    def checkconsistency(self, md, solution, analyses): #{{{
+    def checkconsistency(self, md, solution, analyses):  # {{{
         md = checkfield(md, 'fieldname', 'materials.rho_ice', '>', 0)
         md = checkfield(md, 'fieldname', 'materials.rho_water', '>', 0)
@@ -135,11 +119,5 @@
         md = checkfield(md, 'fieldname', 'materials.effectiveconductivity_averaging', 'numel', [1], 'values', [0, 1, 2])
 
-        if 'GiaAnalysis' in analyses:
-            md = checkfield(md, 'fieldname', 'materials.lithosphere_shear_modulus', '>', 0, 'numel', 1)
-            md = checkfield(md, 'fieldname', 'materials.lithosphere_density', '>', 0, 'numel', 1)
-            md = checkfield(md, 'fieldname', 'materials.mantle_shear_modulus', '>', 0, 'numel', 1)
-            md = checkfield(md, 'fieldname', 'materials.mantle_density', '>', 0, 'numel', 1)
-
-        if 'SealevelriseAnalysis' in analyses:
+        if 'SealevelchangeAnalysis' in analyses:
             md = checkfield(md, 'fieldname', 'materials.earth_density', '>', 0, 'numel', 1)
 
@@ -147,5 +125,5 @@
     # }}}
 
-    def marshall(self, prefix, md, fid): #{{{
+    def marshall(self, prefix, md, fid):  # {{{
         WriteData(fid, prefix, 'name', 'md.materials.type', 'data', 2, 'format', 'Integer')
         WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'rho_ice', 'format', 'Double')
@@ -166,8 +144,4 @@
         WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'rheology_Es', 'format', 'DoubleMat', 'mattype', 1)
         WriteData(fid, prefix, 'data', self.rheology_law, 'name', 'md.materials.rheology_law', 'format', 'String')
-        WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'lithosphere_shear_modulus', 'format', 'Double')
-        WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'lithosphere_density', 'format', 'Double', 'scale', 1.0e3)
-        WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'mantle_shear_modulus', 'format', 'Double')
-        WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'mantle_density', 'format', 'Double', 'scale', 1.0e3)
         WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'earth_density', 'format', 'Double')
     # }}}
Index: issm/trunk/src/m/classes/matice.js
===================================================================
--- issm/trunk/src/m/classes/matice.js	(revision 25994)
+++ issm/trunk/src/m/classes/matice.js	(revision 26744)
@@ -2,27 +2,52 @@
 //
 //   Usage:
-//      matice=matice();
+//      matice = new matice();
 
 function matice(){
+	//properties
+	// {{{
+	this.rho_ice							= 0;
+	this.rho_water							= 0;
+	this.rho_freshwater						= 0;
+	this.mu_water							= 0;
+	this.heatcapacity						= 0;
+	this.latentheat							= 0;
+	this.thermalconductivity				= 0;
+	this.temperateiceconductivity			= 0;
+	this.effectiveconductivity_averaging	= 0;
+	this.meltingpoint						= 0;
+	this.beta								= 0;
+	this.mixed_layer_capacity				= 0;
+	this.thermal_exchange_velocity			= 0;
+	this.rheology_B							= NaN;
+	this.rheology_n							= NaN;
+	this.rheology_law						= '';
+
+	//SLC
+	this.earth_density= 5512; // average density of the Earth, (kg/m^3)
+
+	this.setdefaultparameters();
+	//}}}
+
 	//methods
 	this.setdefaultparameters = function(){ // {{{
 
 		//ice density (kg/m^3)
-		this.rho_ice=917.;
+		this.rho_ice=917;
 
 		//ocean water density (kg/m^3)
-		this.rho_water=1023.;
+		this.rho_water=1023;
 
 		//fresh water density (kg/m^3)
-		this.rho_freshwater=1000.;
+		this.rho_freshwater=1000;
 
 		//water viscosity (N.s/m^2)
-		this.mu_water=0.001787;  
+		this.mu_water=0.001787;
 
 		//ice heat capacity cp (J/kg/K)
-		this.heatcapacity=2093.;
+		this.heatcapacity=2093;
 
 		//ice latent heat of fusion L (J/kg)
-		this.latentheat=3.34*Math.pow(10,5);
+		this.latentheat=3.34*Math.pow(10, 5);
 
 		//ice thermal conductivity (W/m/K)
@@ -32,15 +57,18 @@
 		this.temperateiceconductivity=.24;
 
+		//computation of effective conductivity
+		this.effectiveconductivity_averaging=1;
+
 		//the melting point of ice at 1 atmosphere of pressure in K
 		this.meltingpoint=273.15;
 
 		//rate of change of melting point with pressure (K/Pa)
-		this.beta=9.8*Math.pow(10,-8);
+		this.beta=9.8e-8;
 
 		//mixed layer (ice-water interface) heat capacity (J/kg/K)
-		this.mixed_layer_capacity=3974.;
+		this.mixed_layer_capacity=3974;
 
 		//thermal exchange velocity (ice-water interface) (m/s)
-		this.thermal_exchange_velocity=1.00*Math.pow(10,-4);
+		this.thermal_exchange_velocity=1.00*1e-4;
 
 		//Rheology law: what is the temperature dependence of B with T
@@ -48,12 +76,10 @@
 		this.rheology_law='Paterson';
 
-		// GIA:
-		this.lithosphere_shear_modulus  = 6.7*Math.pow(10,10);  // (Pa)
-		this.lithosphere_density        = 3.32;       // (g/cm^-3)
-		this.mantle_shear_modulus       = 1.45*Math.pow(10,11); // (Pa)
-		this.mantle_density             = 3.34;       // (g/cm^-3)
+		// Rheology for ice
+		this.rheology_B = 2.1 * 1e8
+		this.rheology_n = 3
 
-		//SLR
-		this.earth_density= 5512;  // average density of the Earth, (kg/m^3)
+		//SLC
+		this.earth_density= 5512; // average density of the Earth, (kg/m^3)
 
 
@@ -69,4 +95,5 @@
 		fielddisplay(this,'thermalconductivity','ice thermal conductivity [W/m/K]');
 		fielddisplay(this,'temperateiceconductivity','temperate ice thermal conductivity [W/m/K]');
+		fielddisplay(this,'effectiveconductivity_averaging','computation of effectiveconductivity: (0) arithmetic mean, (1) harmonic mean, (2) geometric mean (default)');
 		fielddisplay(this,'meltingpoint','melting point of ice at 1atm in K');
 		fielddisplay(this,'latentheat','latent heat of fusion [J/kg]');
@@ -75,10 +102,6 @@
 		fielddisplay(this,'thermal_exchange_velocity','thermal exchange velocity [m/s]');
 		fielddisplay(this,'rheology_B','flow law parameter [Pa s^(1/n)]');
-		fielddisplay(this,'rheology_n',"Glen's flow law exponent");
-		fielddisplay(this,'rheology_law',"law for the temperature dependance of the rheology: 'None', 'BuddJacka', 'Cuffey', 'CuffeyTemperate', 'Paterson', 'Arrhenius','LliboutryDuval','NyeH2O', or 'NyeCO2'");
-		fielddisplay(this,'lithosphere_shear_modulus','Lithosphere shear modulus [Pa]');
-		fielddisplay(this,'lithosphere_density','Lithosphere density [g/cm^-3]');
-		fielddisplay(this,'mantle_shear_modulus','Mantle shear modulus [Pa]');
-		fielddisplay(this,'mantle_density','Mantle density [g/cm^-3]');
+		fielddisplay(this,'rheology_n','Glen\'s flow law exponent');
+		fielddisplay(this,'rheology_law','law for the temperature dependance of the rheology: \'None\', \'BuddJacka\', \'Cuffey\', \'CuffeyTemperate\', \'Paterson\', \'Arrhenius\', \'LliboutryDuval\', \'NyeH2O\', or \'NyeCO2\'');
 		fielddisplay(this,'earth_density','Mantle density [kg/m^-3]');
 
@@ -90,26 +113,19 @@
 	}//}}}
 	this.classname = function() {// {{{
-		return "matice";
+		return 'matice';
 	} // }}}
 	this.checkconsistency = function(md,solution,analyses) { // {{{
-		checkfield(md,'fieldname','materials.rho_ice','>',0);
-		checkfield(md,'fieldname','materials.rho_water','>',0);
-		checkfield(md,'fieldname','materials.rho_freshwater','>',0);
-		checkfield(md,'fieldname','materials.mu_water','>',0);
-		checkfield(md,'fieldname','materials.rheology_B','>',0,'timeseries',1,'NaN',1,'Inf',1);
-		checkfield(md,'fieldname','materials.rheology_n','>',0,'size',[md.mesh.numberofelements,1]);
-		checkfield(md,'fieldname','materials.rheology_law','values',['None','BuddJacka','Cuffey','CuffeyTemperate','Paterson','Arrhenius','LliboutryDuval','NyeH2O','NyeCO2']);
-
-		if(ArrayAnyEqual(ArrayIsMember('GiaAnalysis',analyses),1)){
-			checkfield(md,'fieldname','materials.lithosphere_shear_modulus','>',0,'numel',1);
-			checkfield(md,'fieldname','materials.lithosphere_density','>',0,'numel',1);
-			checkfield(md,'fieldname','materials.mantle_shear_modulus','>',0,'numel',1);
-			checkfield(md,'fieldname','materials.mantle_density','>',0,'numel',1);
+		if (solution == 'TransientSolution' && md.transient.isslc) {
+			checkfield(md,'fieldname','materials.earth_density','>',0,'numel',[1])
+		} else {
+			checkfield(md,'fieldname','materials.rho_ice','>',0);
+			checkfield(md,'fieldname','materials.rho_water','>',0);
+			checkfield(md,'fieldname','materials.rho_freshwater','>',0);
+			checkfield(md,'fieldname','materials.mu_water','>',0);
+			checkfield(md,'fieldname','materials.rheology_B','>',0,'universal',1,'NaN',1,'Inf',1);
+			checkfield(md,'fieldname','materials.rheology_n','>',0,'universal',1,'NaN',1,'Inf',1);
+			checkfield(md,'fieldname','materials.rheology_law','values',['None','BuddJacka','Cuffey','CuffeyTemperate','Paterson','Arrhenius','LliboutryDuval','NyeH2O','NyeCO2']);
+			checkfield(md,'fieldname','materials.effectiveconductivity_averaging','numel',[1],'values',[0,1,2])
 		}
-		if (ArrayAnyEqual(ArrayIsMember('SealevelriseAnalysis',analyses),1)){
-			checkfield(md,'fieldname','materials.earth_density','>',0,'numel',1);
-		}
-
-
 	} // }}}
 	this.marshall=function(md,prefix,fid) { //{{{
@@ -123,15 +139,19 @@
 		WriteData(fid,prefix,'object',this,'class','materials','fieldname','thermalconductivity','format','Double');
 		WriteData(fid,prefix,'object',this,'class','materials','fieldname','temperateiceconductivity','format','Double');
+		WriteData(fid,prefix,'object',this,'class','materials','fieldname','effectiveconductivity_averaging','format','Integer');
 		WriteData(fid,prefix,'object',this,'class','materials','fieldname','meltingpoint','format','Double');
 		WriteData(fid,prefix,'object',this,'class','materials','fieldname','beta','format','Double');
 		WriteData(fid,prefix,'object',this,'class','materials','fieldname','mixed_layer_capacity','format','Double');
 		WriteData(fid,prefix,'object',this,'class','materials','fieldname','thermal_exchange_velocity','format','Double');
-		WriteData(fid,prefix,'object',this,'class','materials','fieldname','rheology_B','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+		if ((shape(self.rheology_B)[0] == md.mesh.numberofvertices) || (shape(self.rheology_B)[0] == md.mesh.numberofvertices + 1) or (shape(self.rheology_B)[0] == md.mesh.numberofelements && shape(self.rheology_B)[1] > 1)) {
+			mattype = 1
+			tsl = md.mesh.numberofvertices
+		} else {
+			mattype = 2
+			tsl = md.mesh.numberofelements
+		}
+		WriteData(fid,prefix,'object',this,'class','materials','fieldname','rheology_B','format','DoubleMat','mattype',mattype,'timeserieslength',tsl+1,'yts',md.constants.yts);
 		WriteData(fid,prefix,'object',this,'class','materials','fieldname','rheology_n','format','DoubleMat','mattype',2);
 		WriteData(fid,prefix,'data',this.rheology_law,'name','md.materials.rheology_law','format','String');
-		WriteData(fid,prefix,'object',this,'class','materials','fieldname','lithosphere_shear_modulus','format','Double');
-		WriteData(fid,prefix,'object',this,'class','materials','fieldname','lithosphere_density','format','Double','scale',Math.pow(10,3));
-		WriteData(fid,prefix,'object',this,'class','materials','fieldname','mantle_shear_modulus','format','Double');
-		WriteData(fid,prefix,'object',this,'class','materials','fieldname','mantle_density','format','Double','scale',Math.pow(10,3));
 		WriteData(fid,prefix,'object',this,'class','materials','fieldname','earth_density','format','Double');
 
@@ -139,32 +159,3 @@
 	this.fix=function() { //{{{
 	}//}}}
-	//properties 
-	// {{{
-		this.rho_ice                    = 0.;
-		this.rho_water                  = 0.;
-		this.rho_freshwater             = 0.;
-		this.mu_water                   = 0.;
-		this.heatcapacity               = 0.;
-		this.latentheat                 = 0.;
-		this.thermalconductivity        = 0.;
-		this.temperateiceconductivity   = 0.;
-		this.meltingpoint               = 0.;
-		this.beta                       = 0.;
-		this.mixed_layer_capacity       = 0.;
-		this.thermal_exchange_velocity  = 0.;
-		this.rheology_B   = NaN;
-		this.rheology_n   = NaN;
-		this.rheology_law = '';
-
-		//giaivins: 
-		this.lithosphere_shear_modulus  = 0.;
-		this.lithosphere_density        = 0.;
-		this.mantle_shear_modulus       = 0.;
-		this.mantle_density             = 0.;
-
-		//SLR
-		this.earth_density= 5512;  // average density of the Earth, (kg/m^3)
-
-		this.setdefaultparameters();
-		//}}}
 }
